"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _PriorityQueue2 = require("./PriorityQueue");

var _PriorityQueue3 = _interopRequireDefault(_PriorityQueue2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function heapify(collection, index, comparator) {
  var largestIndex = getLargestIndex(collection, index, comparator);

  if (largestIndex !== index) {
    // swap current & largest
    var t = collection[index];
    collection[index] = collection[largestIndex];
    collection[largestIndex] = t;
    heapify(collection, largestIndex, comparator);
  }
}

function getLargestIndex(collection, index, comparator) {
  var leftIndex = index * 2;
  var rightIndex = index * 2 + 1;
  var largestIndex = index;

  if (leftIndex < collection.length && comparator(collection[largestIndex], collection[leftIndex]) < 0) largestIndex = leftIndex;
  if (rightIndex < collection.length && comparator(collection[largestIndex], collection[rightIndex]) < 0) largestIndex = rightIndex;

  return largestIndex;
}

function heapifyAll(instance) {
  for (var i = Math.floor(instance.collection.length / 2) - 1; i >= 0; --i) {
    heapify(instance.collection, i, instance.comparator);
  }
}

var BinaryHeap = function (_PriorityQueue) {
  _inherits(BinaryHeap, _PriorityQueue);

  function BinaryHeap() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, BinaryHeap);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = BinaryHeap.__proto__ || Object.getPrototypeOf(BinaryHeap)).call.apply(_ref, [this].concat(args))), _this), _this.collection = [], _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(BinaryHeap, [{
    key: "clear",
    value: function clear() {
      this.collection.length = 0;
    }
  }, {
    key: "toArray",
    value: function toArray() {
      return [].concat(_toConsumableArray(this.collection)).sort(this.comparator);
    }
  }, {
    key: "top",
    value: function top() {
      if (this.length === 0) {
        throw new Error("invalid operation: top() called for empty BinaryHeap");
      }
      return this.collection[0];
    }
  }, {
    key: "pop",
    value: function pop() {
      if (this.length === 0) {
        throw new Error("invalid operation: pop() called for empty BinaryHeap");
      }
      var ret = this.collection[0];
      if (1 < this.collection.length) {
        this.collection[0] = this.collection.pop();
        heapify(this.collection, 0, this.comparator);
      } else {
        this.collection.pop();
      }

      return ret;
    }
  }, {
    key: "push",
    value: function push(value) {
      this.collection.push(value);
      var arr = this.collection;
      for (var i = arr.length - 1; i > 0 && this.comparator(arr[Math.floor(i / 2)], arr[i]) < 0; i = Math.floor(i / 2)) {
        var t = arr[i];
        arr[i] = arr[Math.floor(i / 2)];
        arr[Math.floor(i / 2)] = t;
      }
    }
  }, {
    key: "merge",
    value: function merge(other) {
      if (other instanceof BinaryHeap) {
        this.collection = this.collection.concat(other.collection);
      } else {
        this.collection = this.collection.concat(other.toArray());
      }
      heapifyAll(this);
    }
  }, {
    key: "isEmpty",
    value: function isEmpty() {
      return !this.collection.length;
    }
  }, {
    key: "length",
    get: function get() {
      return this.collection.length;
    }
  }], [{
    key: "from",
    value: function from(array) {
      var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var instance = new BinaryHeap(option);
      instance.collection = Array.from(array);
      heapifyAll(instance);
      return instance;
    }
  }]);

  return BinaryHeap;
}(_PriorityQueue3.default);

exports.default = BinaryHeap;