var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

import PriorityQueue from "./PriorityQueue";


function createNode(value) {
  return {
    value: value,
    left: null,
    right: null
  };
}

function traverse(node) {
  if (!node) return [];
  return [].concat(_toConsumableArray(traverse(node.left)), [node.value], _toConsumableArray(traverse(node.right)));
}

function _merge(a, b, comparator) {
  if (!a || !b) return a || b;
  if (comparator(a.value, b.value) < 0) {
    return _merge(b, a, comparator);
  }
  a.right = _merge(a.right, b, comparator);
  var t = a.right;
  a.right = a.left;
  a.left = t;
  return a;
}

var SkewHeap = function (_PriorityQueue) {
  _inherits(SkewHeap, _PriorityQueue);

  function SkewHeap() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, SkewHeap);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SkewHeap.__proto__ || Object.getPrototypeOf(SkewHeap)).call.apply(_ref, [this].concat(args))), _this), _this.root = null, _this._length = 0, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SkewHeap, [{
    key: "clear",
    value: function clear() {
      this._length = 0;
      this.root = null;
    }
  }, {
    key: "push",
    value: function push(val) {
      this.root = _merge(this.root, createNode(val), this.comparator);
      this._length += 1;
    }
  }, {
    key: "top",
    value: function top() {
      if (!this.root) {
        throw new Error("invalid operation: top() called for empty SkewHeap");
      }
      return this.root.value;
    }
  }, {
    key: "pop",
    value: function pop() {
      if (!this.root) {
        throw new Error("invalid operation: pop() called for empty SkewHeap");
      }
      var ret = this.root.value;
      this.root = _merge(this.root.right, this.root.left, this.comparator);
      this._length -= 1;
      return ret;
    }
  }, {
    key: "merge",
    value: function merge(other) {
      if (other instanceof SkewHeap && this.comparator === other.comparator) {
        this.root = _merge(this.root, other.root, this.comparator);
        this._length += other.length;
        return;
      }
      for (var i = 0, a = other.toArray(), l = a.length; i < l; ++i) {
        this.push(a[i]);
      }
    }
  }, {
    key: "toArray",
    value: function toArray() {
      return traverse(this.root).sort(this.comparator);
    }
  }, {
    key: "isEmpty",
    value: function isEmpty() {
      return !this.root;
    }
  }, {
    key: "length",
    get: function get() {
      return this._length;
    }
  }], [{
    key: "from",
    value: function from(array) {
      var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var instance = new SkewHeap(option);
      for (var i = 0, l = array.length; i < l; ++i) {
        instance.push(array[i]);
      }
      return instance;
    }
  }]);

  return SkewHeap;
}(PriorityQueue);

export default SkewHeap;